<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="permissions-wrapper permissions-holder">
        <div class="row">
            <div class="col-3">
                <div class="permission-left">
                    <div class="row">
                        <div class="col-11">
                            <div class="permissions-wrapper-top">
                                <div class="permission-title">Owner</div>
                            </div>
                            <!-- <UserItem :bigger="true" :data="userProfile" /> -->
                            <div class="permissions-wrapper-owner">
                                <WelcomeUser :user="loggedUser" />
                            </div>
                            <div class="permission-left-filters">
                                <div class="permission-left-filters-title">Filter by permission</div>
                                <FilterItem :all="true" @click="filterRolesByPermission(null)"
                                    :total="numberOfUsersWithAllPermissions"
                                    :isSelected="selectedPermissionId === null" />
                                <FilterItem v-for="permission in permissions" :key="permission.id"
                                    @click="filterRolesByPermission(permission.id)" :permission="permission"
                                    :total="getTotalForPermission(permission.id)"
                                    :isSelected="selectedPermissionId === permission.id" />
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-4">
                <div class="permission-middle">
                    <div class="row">
                        <div class="offset-1 col-10">
                            <div class="permissions-wrapper-top">
                                <div class="permission-title">Roles</div>
                                <FiltersTopVariant :name="`Roles`" />
                            </div>
                            <div class="accordion" id="accordionRole">
                                <div class="accordion-item">
                                    <h2 class="accordion-header" id="heading-role1">
                                        <button class="accordion-button" type="button" data-bs-toggle="collapse"
                                            data-bs-target="#roles1" aria-expanded="true" aria-controls="roles1">
                                            Have permissions
                                        </button>
                                    </h2>
                                    <div id="roles1" class="accordion-collapse collapse show"
                                        aria-labelledby="heading-role1" data-bs-parent="#accordionRole">
                                        <div class="accordion-body">
                                            <CardsCardRole :userList="userList" :all="true"
                                                :permissionSelectedId="selectedPermissionId ? selectedPermissionId : 0"
                                                @click="filterUsersByPermissions(selectedPermissionId)"
                                                :selected="selectedRoleId === 0" />
                                            <CardsCardRole v-for="role in filteredRoles" :key="role.id" :role="role"
                                                :userList="userList"
                                                @click="filterUsersByRoleAndPermissions(role, role.id)"
                                                :selected="role.id === selectedRoleId" />
                                        </div>
                                    </div>
                                </div>
                                <div class="accordion-item">
                                    <h2 class="accordion-header" id="heading-role2">
                                        <button class="accordion-button" type="button" data-bs-toggle="collapse"
                                            data-bs-target="#collapse-role2" aria-expanded="true"
                                            aria-controls="collapse-role2">
                                            Exceptions
                                        </button>
                                    </h2>
                                    <div id="collapse-role2" class="accordion-collapse collapse show"
                                        aria-labelledby="heading-role2" data-bs-parent="#accordionRole">
                                        <div class="accordion-body">
                                            <CardsCardRole v-for="role in inverseFilteredRoles" :key="role.id"
                                                :role="role" :userList="userList"
                                                @click="filterUsersByRoleAndPermissions(role, role.id)"
                                                :selected="role.id === selectedRoleId" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-5">
                <div class="permission-right">
                    <div class="row">
                        <div class="offset-1 col-11">
                            <div class="permissions-wrapper-top">
                                <div class="permission-title">Owner</div>
                                <FiltersTopVariant :name="`Users`" />
                            </div>
                            <div class="accordion" id="accordion-user">
                                <div class="accordion-item">
                                    <h2 class="accordion-header" id="heading-user1">
                                        <button class="accordion-button" type="button" data-bs-toggle="collapse"
                                            data-bs-target="#collapse-user1" aria-expanded="true"
                                            aria-controls="collapse-user1">
                                            Have permissions
                                        </button>
                                    </h2>
                                    <div id="collapse-user1" class="accordion-collapse collapse show"
                                        aria-labelledby="heading-user1" data-bs-parent="#accordion-user">
                                        <div class="accordion-body">
                                            <UserItemLine v-for="user in filteredUsers" :key="user.id" :user="user"
                                                :roles="roles" />
                                        </div>
                                    </div>
                                </div>
                                <div class="accordion-item">
                                    <h2 class="accordion-header" id="heading-user2">
                                        <button class="accordion-button" type="button" data-bs-toggle="collapse"
                                            data-bs-target="#collapse-user2" aria-expanded="true"
                                            aria-controls="collapse-user2">
                                            Exceptions
                                        </button>
                                    </h2>
                                    <div id="collapse-user2" class="accordion-collapse collapse show"
                                        aria-labelledby="heading-user2" data-bs-parent="#accordion-user">
                                        <div class="accordion-body">
                                            <UserItemLine v-for="user in inverseFilteredUsers" :key="user.id"
                                                :user="user" :roles="roles" />
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script setup lang="ts">
import type userI from '~/interfaces/user';

// const userProfile = {
//     id: 1,
//     img: 'https://via.placeholder.com/150x50',
//     name: 'Edgar Amorim',
//     role: 'Data Scientist'
// }

const dummyClick = () => {
    console.log('dummyClick');
}

const loggedUser = ref<userI>(
    {
        id: 1,
        name: 'Edgar Amorim',
        img: '@/assets/images/user_3.png',
        role: 'Data Scientist',
        info: []
    }
)

interface userListArray {
    id: number;
    name: string;
    img: string;
    role: number;
    permissions: number[]
}

const userList = [
    {
        id: 1,
        name: 'Edgar Amorim',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 3,
        permissions: [1, 2, 3]
    },
    {
        id: 2,
        name: 'Sara Ribeiro',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 2,
        permissions: [1, 2]
    },
    {
        id: 3,
        name: 'Daniela Silva',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 1,
        permissions: [1, 2, 3]
    },
    {
        id: 4,
        name: 'Nuno Alves',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 3,
        permissions: [1]
    },
    {
        id: 5,
        name: 'Sofia Alves',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 1,
        permissions: []
    },
    {
        id: 6,
        name: 'Leonor Ribeiro',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 4,
        permissions: [1, 2]
    },
    {
        id: 7,
        name: 'David Pinho',
        img: new URL('@/assets/images/user_3.png', import.meta.url).href,
        role: 5,
        permissions: [1, 2, 3]
    }
]

interface rolesArray {
    id: number;
    img: string;
    role_type: string;
    role_designation: string;
    permissions: number[]
}

const roles = ref<rolesArray[]>([
    {
        id: 1,
        img: 'https://via.placeholder.com/44x44',
        role_type: 'Healthcare Professionals',
        role_designation: 'Healthcare Professional',
        permissions: [1]
    },
    {
        id: 2,
        img: 'https://via.placeholder.com/44x44',
        role_type: 'Policy Makers',
        role_designation: 'Policy Maker',
        permissions: [1, 2]
    },
    {
        id: 3,
        img: 'https://via.placeholder.com/44x44',
        role_type: 'Analysts',
        role_designation: 'Analyst',
        permissions: []
    },
    {
        id: 4,
        img: 'https://via.placeholder.com/44x44',
        role_type: 'Developers',
        role_designation: 'Developer',
        permissions: [1, 2]
    },
    {
        id: 5,
        img: 'https://via.placeholder.com/44x44',
        role_type: 'Directors',
        role_designation: 'Director',
        permissions: [1, 2, 3]
    }
])

interface PermissionsArray {
    id: number;
    type: string;
}

const permissions = ref<PermissionsArray[]>([
    {
        id: 1,
        type: 'can see'
    },
    {
        id: 2,
        type: 'can edit'
    },
    {
        id: 3,
        type: 'can share'
    }
])

// Get users with all permissions
const usersWithAllPermissions = userList.filter(user => {
    return permissions.value.every(permission => user.permissions.includes(permission.id));
});

const numberOfUsersWithAllPermissions = usersWithAllPermissions.length;

// Get users with see permissions
const usersWithPermissionSee = userList.filter(user => {
    return user.permissions.includes(1);
});

// Get users with edit permissions
const usersWithPermissionEdit = userList.filter(user => {
    return user.permissions.includes(2);
});

// Get users with share permissions
const usersWithPermissionShare = userList.filter(user => {
    return user.permissions.includes(3);
});

// Get total of users with each permission
const getTotalForPermission = (permissionId: number) => {
    switch (permissionId) {
        case 1:
            return usersWithPermissionSee.length;
        case 2:
            return usersWithPermissionEdit.length;
        case 3:
            return usersWithPermissionShare.length;
        default:
            return 0;
    }
};

const selectedPermissionId = ref<number | null>(null);

// Computed property to filter roles based on the selected permission
const filteredRoles = computed(() => {
    if (selectedPermissionId.value === null) {
        return roles.value.filter(role =>
            role.permissions.includes(1) &&
            role.permissions.includes(2) &&
            role.permissions.includes(3)
        );
    } else {
        return roles.value.filter(role => role.permissions.includes(selectedPermissionId.value!));
    }
});

// Function to filter roles based on the selected permission
const filterRolesByPermission = (permissionId: number | null) => {
    selectedPermissionId.value = permissionId;
};

const inverseFilteredRoles = computed(() => {
    return roles.value.filter(role => !filteredRoles.value.includes(role));
});

const filteredUsers = ref<userListArray[]>([]);
const selectedRoleId = ref<number | null>(null);

// Method to filter users by role and permissions
const filterUsersByRoleAndPermissions = (role: rolesArray, roleId: number) => {
    selectedRoleId.value = roleId === selectedRoleId.value ? null : roleId;
    // Filter userList based on the selected role and its permissions
    filteredUsers.value = userList.filter(user => {
        return user.role === role.id && role.permissions.every(permissionId => user.permissions.includes(permissionId));
    });
}

const filterUsersByPermissions = (permissionId: number | null) => {
    selectedRoleId.value = 0;
    // Filter userList based on the selected permission
    if (permissionId) {
        filteredUsers.value = userList.filter(user => { return user.permissions.includes(permissionId) });
    } else {
        return filteredUsers.value = userList.filter(user =>
            user.permissions.includes(1) &&
            user.permissions.includes(2) &&
            user.permissions.includes(3)
        );
    }
}

const inverseFilteredUsers = computed(() => {
    // console.log("aqui", selectedRoleId.value)
    if (!selectedRoleId.value || selectedRoleId.value === 0) {
        return userList.filter(user => !filteredUsers.value.includes(user));
    } else {
        return userList.filter(user => !filteredUsers.value.includes(user) && user.role === selectedRoleId.value);
    }

});

</script>